package com.games.gateway.config;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.games.gateway.domain.Result;
import com.games.gateway.exceptions.BizException;
import com.games.gateway.utils.TraceUtils;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.web.reactive.error.ErrorWebExceptionHandler;
import org.springframework.core.annotation.Order;
import org.springframework.core.io.buffer.DataBufferFactory;
import org.springframework.http.MediaType;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.web.server.ResponseStatusException;
import org.springframework.web.server.ServerWebExchange;
import org.springframework.web.server.handler.ResponseStatusExceptionHandler;
import reactor.core.publisher.Mono;

/**
 * 网关异常通用处理器，只作用在webflux 环境下 , 优先级低于 {@link ResponseStatusExceptionHandler} 执行
 *
 * @author 冷酱
 * @date 2020/5/26
 */
@Component
@Slf4j
@Order(-1)
@RequiredArgsConstructor
public class GlobalExceptionHandler implements ErrorWebExceptionHandler {

	private final ObjectMapper objectMapper;

	@Override
	public Mono<Void> handle(ServerWebExchange exchange, Throwable ex) {
		ServerHttpResponse response = exchange.getResponse();

		if (response.isCommitted()) {
			return Mono.error(ex);
		}

		// header set
		response.getHeaders().setContentType(MediaType.APPLICATION_JSON);
		if (ex instanceof ResponseStatusException) {
			response.setStatusCode(((ResponseStatusException) ex).getStatus());
		}

		return response.writeWith(Mono.fromSupplier(() -> {
			DataBufferFactory bufferFactory = response.bufferFactory();
			try {
				log.error("发生系统异常",ex);
				if(ex instanceof BizException){
					BizException currentEx = (BizException)ex;
					Result result = new Result( currentEx.getErrorCode(),currentEx.getErrorMsg());
					result.setTraceId(TraceUtils.getTraceId());
					TraceUtils.removeTraceId();
					return bufferFactory.wrap(objectMapper.writeValueAsBytes(result));
				}else if(ex instanceof  ResponseStatusException ){
					Result result = new Result("",ex.getMessage(),Result.Status.ERROR);
					result.setTraceId(TraceUtils.getTraceId());
					TraceUtils.removeTraceId();
					return bufferFactory.wrap(objectMapper.writeValueAsBytes(result));
				}else {
					Result result = new Result("","system error",Result.Status.ERROR);
					result.setTraceId(TraceUtils.getTraceId());
					TraceUtils.removeTraceId();
					return bufferFactory.wrap(objectMapper.writeValueAsBytes(result));
				}
			}
			catch (JsonProcessingException e) {
				log.error("Error writing response", ex);
				return bufferFactory.wrap(new byte[0]);
			}
		}));
	}
}